//
//  HttpAsyncSocket.h
//  Fuze
//
//  Created by Angel Terziev on 12/19/11.
//  Copyright 2011 aterziev@fuzebox.com. All rights reserved.
//

#import "AsyncSocket.h"

#import "CommunicationAuthentication.h"


@interface HttpAsyncSocket : AsyncSocket
{
    NSString*       _dstHost;
    unsigned short  _dstPort;
    BOOL            _dstSsl;

    NSString* _username;
    NSString* _password;

    NSMutableArray* _queuedPackets;
    BOOL            _handshakeFinished;

    NSRunLoop* _runLoop;
    NSRunLoop* _runLoopWrite;

    CommunicationAuthentication* _authentication;

    BOOL            _didSendAfterHandshake;

    NSMutableData*  _httpResponseData;
}

- ( id )
initWithHost:   ( NSString*      ) host
port:           ( unsigned short ) port
proxyHost:      ( NSString*      ) proxyHost
proxyPort:      ( unsigned short ) proxyPort
ssl:            ( BOOL           ) ssl
runLoop:        ( NSRunLoop*     ) runLoop
runLoopWrite:   ( NSRunLoop*     ) runLoopWrite
context:        ( void *         ) context
username:       ( NSString*      ) username
password:       ( NSString*      ) password;

@end
